/*
 * @(#)UsmStats.java	1.14
 *
 * 
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright (c) 2007 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU General
 * Public License Version 2 only ("GPL") or the Common Development and
 * Distribution License("CDDL")(collectively, the "License"). You may not use
 * this file except in compliance with the License. You can obtain a copy of the
 * License at http://opendmk.dev.java.net/legal_notices/licenses.txt or in the 
 * LEGAL_NOTICES folder that accompanied this code. See the License for the 
 * specific language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file found at
 *     http://opendmk.dev.java.net/legal_notices/licenses.txt
 * or in the LEGAL_NOTICES folder that accompanied this code.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.
 * 
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * 
 *       "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding
 * 
 *       "[Contributor] elects to include this software in this distribution
 *        under the [CDDL or GPL Version 2] license."
 * 
 * If you don't indicate a single choice of license, a recipient has the option
 * to distribute your version of this file under either the CDDL or the GPL
 * Version 2, or to extend the choice of license to its licensees as provided
 * above. However, if you add GPL Version 2 code and therefore, elected the
 * GPL Version 2 license, then the option applies only if the new code is made
 * subject to such option by the copyright holder.
 * 
 *
 */
package com.sun.management.snmp.usm.usmmib;

//
// Generated by mibgen version 5.0 (09/06/01) when compiling SNMP-USER-BASED-SM-MIB.
//

// java imports
//
import java.io.Serializable;

// jmx imports
//
import javax.management.MBeanServer;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStatusException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;

/**
 * The class is used for implementing the "UsmStats" group.
 * The group is defined with the following oid: 1.3.6.1.6.3.15.1.1.
 *
 *
 * @since Java DMK 5.1
 */
public class UsmStats implements UsmStatsMBean, Serializable {
    private static final long serialVersionUID = -2435643288394990868L;

    /**
     * Variable for storing the value of "UsmStatsDecryptionErrors".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.6".
     */
    protected Long UsmStatsDecryptionErrors = new Long(1);

    /**
     * Variable for storing the value of "UsmStatsWrongDigests".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.5".
     */
    protected Long UsmStatsWrongDigests = new Long(1);

    /**
     * Variable for storing the value of "UsmStatsUnknownEngineIDs".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.4".
     */
    protected Long UsmStatsUnknownEngineIDs = new Long(1);

    /**
     * Variable for storing the value of "UsmStatsUnknownUserNames".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.3".
     */
    protected Long UsmStatsUnknownUserNames = new Long(1);

    /**
     * Variable for storing the value of "UsmStatsNotInTimeWindows".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.2".
     */
    protected Long UsmStatsNotInTimeWindows = new Long(1);

    /**
     * Variable for storing the value of "UsmStatsUnsupportedSecLevels".
     * The variable is identified by: "1.3.6.1.6.3.15.1.1.1".
     */
    protected Long UsmStatsUnsupportedSecLevels = new Long(1);


    /**
     * Constructor for the "UsmStats" group.
     * If the group contains a table, the entries created through an SNMP SET will not be registered in Java DMK.
     */
    public UsmStats(SnmpMib myMib) {
    }


    /**
     * Constructor for the "UsmStats" group.
     * If the group contains a table, the entries created through an SNMP SET will be AUTOMATICALLY REGISTERED in Java DMK.
     */
    public UsmStats(SnmpMib myMib, MBeanServer server) {
    }

    /**
     * Getter for the "UsmStatsDecryptionErrors" variable.
     */
    public Long getUsmStatsDecryptionErrors() throws SnmpStatusException {
        return UsmStatsDecryptionErrors;
    }

    /**
     * Getter for the "UsmStatsWrongDigests" variable.
     */
    public Long getUsmStatsWrongDigests() throws SnmpStatusException {
        return UsmStatsWrongDigests;
    }

    /**
     * Getter for the "UsmStatsUnknownEngineIDs" variable.
     */
    public Long getUsmStatsUnknownEngineIDs() throws SnmpStatusException {
        return UsmStatsUnknownEngineIDs;
    }

    /**
     * Getter for the "UsmStatsUnknownUserNames" variable.
     */
    public Long getUsmStatsUnknownUserNames() throws SnmpStatusException {
        return UsmStatsUnknownUserNames;
    }

    /**
     * Getter for the "UsmStatsNotInTimeWindows" variable.
     */
    public Long getUsmStatsNotInTimeWindows() throws SnmpStatusException {
        return UsmStatsNotInTimeWindows;
    }

    /**
     * Getter for the "UsmStatsUnsupportedSecLevels" variable.
     */
    public Long getUsmStatsUnsupportedSecLevels() throws SnmpStatusException {
        return UsmStatsUnsupportedSecLevels;
    }

}
