/*
 * @(#)file      SimpleNode.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   4.15
 * @(#)date      07/10/01
 *
 * 
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright (c) 2007 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU General
 * Public License Version 2 only ("GPL") or the Common Development and
 * Distribution License("CDDL")(collectively, the "License"). You may not use
 * this file except in compliance with the License. You can obtain a copy of the
 * License at http://opendmk.dev.java.net/legal_notices/licenses.txt or in the 
 * LEGAL_NOTICES folder that accompanied this code. See the License for the 
 * specific language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file found at
 *     http://opendmk.dev.java.net/legal_notices/licenses.txt
 * or in the LEGAL_NOTICES folder that accompanied this code.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.
 * 
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * 
 *       "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding
 * 
 *       "[Contributor] elects to include this software in this distribution
 *        under the [CDDL or GPL Version 2] license."
 * 
 * If you don't indicate a single choice of license, a recipient has the option
 * to distribute your version of this file under either the CDDL or the GPL
 * Version 2, or to extend the choice of license to its licensees as provided
 * above. However, if you add GPL Version 2 code and therefore, elected the
 * GPL Version 2 license, then the option applies only if the new code is made
 * subject to such option by the copyright holder.
 * 
 *
 */


/* Generated By:JJTree: Do not edit this line. SimpleNode.java */

package com.sun.jdmk.tools.mibgen;

import java.util.*;

public class SimpleNode implements Node {
    protected Node parent;
    protected Node[] children;
    protected int id;
    protected Parser parser;

    public SimpleNode(int i) {
        id = i;
    }

    public SimpleNode(Parser p, int i) {
        this(i);
        parser = p;
    }

    public static Node jjtCreate(int id) {
        return new SimpleNode(id);
    }

    public static Node jjtCreate(Parser p, int id) {
        return new SimpleNode(p, id);
    }

    public void jjtOpen() {
    }

    public void jjtClose() {
    }
  
    public void jjtSetParent(Node n) { parent = n; }
    public Node jjtGetParent() { return parent; }

    public void jjtAddChild(Node n, int i) {
        if (children == null) {
            children = new Node[i + 1];
        } else if (i >= children.length) {
            Node c[] = new Node[i + 1];
            System.arraycopy(children, 0, c, 0, children.length);
            children = c;
        }
        children[i] = n;
    }

    public Node jjtGetChild(int i) {
        return children[i];
    }

    public int jjtGetNumChildren() {
        return (children == null) ? 0 : children.length;
    }
  
    public String getDefValInitializer(String strMbeanSyntax, ASTNamedType syntax, String varName) {
        return new String();
    }
    
    /* SR */
    public SimpleNode getChildOfType(int type) {
        if (children == null)
            return null;
    
        for(int i=0; i < children.length; i++) {
            if ( ((SimpleNode)children[i]).id == type)
                return (SimpleNode) children[i];
        }
        return null;
    }
    
    public ASTMib getMib() {
        
        if ((parent == null) || !(parent instanceof SimpleNode))
            return null;
        else if (id == ParserTreeConstants.JJTMIB) 
            return (ASTMib)this;
        else
            return ((SimpleNode)parent).getMib();
    }
  
    /**
     * Index resolution. Propagate through the tree ...
     */
    public void validateIndexNames(IdentifierHandler handler) {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    n.validateIndexNames(handler);
                }
            } /* end of loop */
        }                     
    }

    /**
     * symbol resolution.
     */
    public void  resolve(IdentifierHandler symbolsHandler, String key) {
    }
  
    /**
     * Syntax resolution. Propagate through the tree ...
     */
    public void resolve(SyntaxHandler handler) {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    n.resolve(handler);
                }
            } /* end of loop */
      
        }
    }
  
    public SimpleNode getResolver() {
        return null;
    }
  
    public void setResolver(SimpleNode node) {
    
    }
  
    public StringBuffer computeValue(Vector referenceList) throws SemanticException {
        return new StringBuffer();
    }
  
    public boolean isSequenceOfType() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    if (n.isSequenceOfType()== true)
                        return true;
                }
            }
        }
        return false;
    }
  
    public boolean isEnumeratedType() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    if (n.isEnumeratedType()== true)
                        return true;
                }
            }
        }
        return false;
    }
  
    public Enumerated getEnumeratedDef() {
        if (isEnumeratedType() == false) {
            return new Enumerated();
        }
    
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    Enumerated vv= n.getEnumeratedDef();
                    if (vv.isEmpty()== false)
                        return vv;
                }
            }
        }
        return new Enumerated();
    }
  
    public boolean isEnumeratedBITSType() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    if (n.isEnumeratedBITSType()== true)
                        return true;
                }
            }
        }
        return false;
    }
  
    public Enumerated getEnumeratedBITSDef() {
        if (isEnumeratedBITSType() == false) {
            return new Enumerated();
        }
    
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    Enumerated vv= n.getEnumeratedBITSDef();
                    if (vv.isEmpty()== false)
                        return vv;
                }
            }
        }
        return new Enumerated();
    }
  
    public String getSnmpSyntax() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    String syntax= n.getSnmpSyntax();
                    if (syntax.length() != 0)
                        return syntax;
                }
            }
        }
        return "";
    }
  
    public String getTypeReferenceName() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    String syntax= n.getTypeReferenceName();
                    if (syntax != null)
                        return syntax;
                }
            }
        }
        return null;
    }
  
    public long getFixedLength() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    long length= n.getFixedLength();
                    if (length != -1) {
                        return length;
                    }            
                }
            }
        }
        return -1;
    }
  
    public String getMbeanSyntax() {
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    String syntax= n.getMbeanSyntax();
                    if (syntax.length() != 0)
                        return syntax;
                }
            }
        }
        return "";
    }
  
    /* END SR */
  
    /* You can override these two methods in subclasses of SimpleNode to
       customize the way the node appears when the tree is dumped.  If
       your output uses more than one line you should override
       toString(String), otherwise overriding toString() is probably all
       you need to do. */

    public String toString() { return ParserTreeConstants.jjtNodeName[id]; }
    public String toString(String prefix) { return prefix + toString(); }

    /* Override this method if you want to customize how the node dumps
       out its children. */

    public void dump(String prefix) {
        System.out.println(toString(prefix));
        if (children != null) {
            for (int i = 0; i < children.length; ++i) {
                SimpleNode n = (SimpleNode)children[i];
                if (n != null) {
                    n.dump(prefix + " ");
                }
            }
        }
    }
}

